package com.upsight.android.analytics.internal;

import android.app.Application;
import com.google.gson.Gson;
import com.upsight.android.UpsightAnalyticsExtension;
import com.upsight.android.UpsightAnalyticsExtension_MembersInjector;
import com.upsight.android.UpsightContext;
import com.upsight.android.analytics.UpsightAnalyticsApi;
import com.upsight.android.analytics.UpsightGooglePlayHelper;
import com.upsight.android.analytics.UpsightLifeCycleTracker;
import com.upsight.android.analytics.internal.association.AssociationManager;
import com.upsight.android.analytics.internal.association.AssociationModule;
import com.upsight.android.analytics.internal.association.AssociationModule_ProvideAssociationManagerFactory;
import com.upsight.android.analytics.internal.configuration.ConfigurationManager;
import com.upsight.android.analytics.internal.configuration.ConfigurationModule;
import com.upsight.android.analytics.internal.configuration.ConfigurationModule_ProvideConfigurationManagerFactory;
import com.upsight.android.analytics.internal.configuration.ConfigurationResponseParser;
import com.upsight.android.analytics.internal.configuration.ConfigurationResponseParser_Factory;
import com.upsight.android.analytics.internal.configuration.ManagerConfigParser;
import com.upsight.android.analytics.internal.configuration.ManagerConfigParser_Factory;
import com.upsight.android.analytics.internal.dispatcher.DispatchModule;
import com.upsight.android.analytics.internal.dispatcher.DispatchModule_ProvideDispatcherFactory;
import com.upsight.android.analytics.internal.dispatcher.Dispatcher;
import com.upsight.android.analytics.internal.dispatcher.delivery.DeliveryModule;
import com.upsight.android.analytics.internal.dispatcher.delivery.DeliveryModule_ProvideQueueBuilderFactory;
import com.upsight.android.analytics.internal.dispatcher.delivery.DeliveryModule_ProvideResponseVerifierFactory;
import com.upsight.android.analytics.internal.dispatcher.delivery.QueueBuilder;
import com.upsight.android.analytics.internal.dispatcher.delivery.ResponseParser_Factory;
import com.upsight.android.analytics.internal.dispatcher.delivery.SignatureVerifier;
import com.upsight.android.analytics.internal.dispatcher.routing.RouterBuilder;
import com.upsight.android.analytics.internal.dispatcher.routing.RoutingModule;
import com.upsight.android.analytics.internal.dispatcher.routing.RoutingModule_ProvideRouterBuilderFactory;
import com.upsight.android.analytics.internal.dispatcher.schema.SchemaModule;
import com.upsight.android.analytics.internal.dispatcher.schema.SchemaModule_ProvideSchemaSelectorBuilderFactory;
import com.upsight.android.analytics.internal.dispatcher.schema.SchemaSelectorBuilder;
import com.upsight.android.analytics.internal.provider.LocationTracker_Factory;
import com.upsight.android.analytics.internal.provider.OptOutStatus_Factory;
import com.upsight.android.analytics.internal.provider.ProviderModule;
import com.upsight.android.analytics.internal.provider.ProviderModule_ProvidesOptOutStatusFactory;
import com.upsight.android.analytics.internal.provider.ProviderModule_ProvidesUpsightLocationTrackerFactory;
import com.upsight.android.analytics.internal.provider.ProviderModule_ProvidesUpsightUserAttributesFactory;
import com.upsight.android.analytics.internal.provider.UserAttributes_Factory;
import com.upsight.android.analytics.internal.session.ActivityLifecycleTracker;
import com.upsight.android.analytics.internal.session.ActivityLifecycleTracker_Factory;
import com.upsight.android.analytics.internal.session.Clock;
import com.upsight.android.analytics.internal.session.ConfigParser_Factory;
import com.upsight.android.analytics.internal.session.LifecycleTrackerModule;
import com.upsight.android.analytics.internal.session.LifecycleTrackerModule_ProvideManualTrackerFactory;
import com.upsight.android.analytics.internal.session.LifecycleTrackerModule_ProvideUpsightLifeCycleCallbacksFactory;
import com.upsight.android.analytics.internal.session.ManualTracker_Factory;
import com.upsight.android.analytics.internal.session.SessionManager;
import com.upsight.android.analytics.internal.session.SessionManagerImpl;
import com.upsight.android.analytics.internal.session.SessionModule;
import com.upsight.android.analytics.internal.session.SessionModule_ProvidesSessionManagerFactory;
import com.upsight.android.analytics.internal.session.SessionModule_ProvidesSessionManagerImplFactory;
import com.upsight.android.analytics.provider.UpsightLocationTracker;
import com.upsight.android.analytics.provider.UpsightOptOutStatus;
import com.upsight.android.analytics.provider.UpsightUserAttributes;
import com.upsight.android.internal.util.Opt;
import dagger.MembersInjector;
import dagger.internal.DoubleCheck;
import dagger.internal.MembersInjectors;
import dagger.internal.Preconditions;
import javax.annotation.Generated;
import javax.inject.Provider;
import rx.Scheduler;

@Generated(
  value = "dagger.internal.codegen.ComponentProcessor",
  comments = "https://google.github.io/dagger"
)
public final class DaggerAnalyticsComponent implements AnalyticsComponent {
  private Provider<Opt<Thread.UncaughtExceptionHandler>> provideUncaughtExceptionHandlerProvider;

  private Provider<UpsightContext> provideUpsightContextProvider;

  private Provider<Gson> provideConfigGsonProvider;

  @SuppressWarnings("rawtypes")
  private Provider configParserProvider;

  private Provider<Clock> provideClockProvider;

  private Provider<SessionManagerImpl> providesSessionManagerImplProvider;

  private Provider<SessionManager> providesSessionManagerProvider;

  @SuppressWarnings("rawtypes")
  private Provider manualTrackerProvider;

  private Provider<UpsightLifeCycleTracker> provideManualTrackerProvider;

  private Provider<SchemaSelectorBuilder> provideSchemaSelectorBuilderProvider;

  private Provider<AssociationManager> provideAssociationManagerProvider;

  @SuppressWarnings("rawtypes")
  private Provider optOutStatusProvider;

  private Provider<UpsightOptOutStatus> providesOptOutStatusProvider;

  @SuppressWarnings("rawtypes")
  private Provider locationTrackerProvider;

  private Provider<UpsightLocationTracker> providesUpsightLocationTrackerProvider;

  @SuppressWarnings("rawtypes")
  private Provider userAttributesProvider;

  private Provider<UpsightUserAttributes> providesUpsightUserAttributesProvider;

  private Provider<UpsightGooglePlayHelper> provideGooglePlayHelperProvider;

  private Provider<Analytics> analyticsProvider;

  private Provider<UpsightAnalyticsApi> provideUpsightAnalyticsApiProvider;

  private Provider<ActivityLifecycleTracker> activityLifecycleTrackerProvider;

  private Provider<Application.ActivityLifecycleCallbacks> provideUpsightLifeCycleCallbacksProvider;

  private MembersInjector<UpsightAnalyticsExtension> upsightAnalyticsExtensionMembersInjector;

  private Provider<ConfigurationResponseParser> configurationResponseParserProvider;

  private Provider<ManagerConfigParser> managerConfigParserProvider;

  private Provider<ConfigurationManager> provideConfigurationManagerProvider;

  private Provider<AnalyticsContext> analyticsContextProvider;

  @SuppressWarnings("rawtypes")
  private Provider configParserProvider2;

  private Provider<Scheduler> provideSendingExecutorProvider;

  private Provider<Scheduler> provideSchedulingExecutorProvider;

  private Provider<SignatureVerifier> provideResponseVerifierProvider;

  @SuppressWarnings("rawtypes")
  private Provider responseParserProvider;

  private Provider<QueueBuilder> provideQueueBuilderProvider;

  private Provider<RouterBuilder> provideRouterBuilderProvider;

  private Provider<Dispatcher> provideDispatcherProvider;

  private MembersInjector<DispatcherService> dispatcherServiceMembersInjector;

  private DaggerAnalyticsComponent(Builder builder) {
    assert builder != null;
    initialize(builder);
  }

  public static Builder builder() {
    return new Builder();
  }

  @SuppressWarnings("unchecked")
  private void initialize(final Builder builder) {

    this.provideUncaughtExceptionHandlerProvider =
        DoubleCheck.provider(
            BaseAnalyticsModule_ProvideUncaughtExceptionHandlerFactory.create(
                builder.baseAnalyticsModule));

    this.provideUpsightContextProvider =
        DoubleCheck.provider(
            BaseAnalyticsModule_ProvideUpsightContextFactory.create(builder.baseAnalyticsModule));

    this.provideConfigGsonProvider =
        DoubleCheck.provider(
            ConfigGsonModule_ProvideConfigGsonFactory.create(
                builder.configGsonModule, provideUpsightContextProvider));

    this.configParserProvider = ConfigParser_Factory.create(provideConfigGsonProvider);

    this.provideClockProvider =
        DoubleCheck.provider(
            BaseAnalyticsModule_ProvideClockFactory.create(builder.baseAnalyticsModule));

    this.providesSessionManagerImplProvider =
        DoubleCheck.provider(
            SessionModule_ProvidesSessionManagerImplFactory.create(
                builder.sessionModule,
                provideUpsightContextProvider,
                configParserProvider,
                provideClockProvider));

    this.providesSessionManagerProvider =
        DoubleCheck.provider(
            SessionModule_ProvidesSessionManagerFactory.create(
                builder.sessionModule, providesSessionManagerImplProvider));

    this.manualTrackerProvider =
        DoubleCheck.provider(
            ManualTracker_Factory.create(
                ((MembersInjector) MembersInjectors.noOp()),
                providesSessionManagerProvider,
                provideUpsightContextProvider));

    this.provideManualTrackerProvider =
        DoubleCheck.provider(
            LifecycleTrackerModule_ProvideManualTrackerFactory.create(
                builder.lifecycleTrackerModule, manualTrackerProvider));

    this.provideSchemaSelectorBuilderProvider =
        DoubleCheck.provider(
            SchemaModule_ProvideSchemaSelectorBuilderFactory.create(
                builder.schemaModule, provideUpsightContextProvider));

    this.provideAssociationManagerProvider =
        DoubleCheck.provider(
            AssociationModule_ProvideAssociationManagerFactory.create(
                builder.associationModule, provideUpsightContextProvider, provideClockProvider));

    this.optOutStatusProvider =
        DoubleCheck.provider(
            OptOutStatus_Factory.create(
                ((MembersInjector) MembersInjectors.noOp()), provideUpsightContextProvider));

    this.providesOptOutStatusProvider =
        DoubleCheck.provider(
            ProviderModule_ProvidesOptOutStatusFactory.create(
                builder.providerModule, optOutStatusProvider));

    this.locationTrackerProvider =
        DoubleCheck.provider(
            LocationTracker_Factory.create(
                ((MembersInjector) MembersInjectors.noOp()), provideUpsightContextProvider));

    this.providesUpsightLocationTrackerProvider =
        DoubleCheck.provider(
            ProviderModule_ProvidesUpsightLocationTrackerFactory.create(
                builder.providerModule, locationTrackerProvider));

    this.userAttributesProvider =
        DoubleCheck.provider(
            UserAttributes_Factory.create(
                ((MembersInjector) MembersInjectors.noOp()), provideUpsightContextProvider));

    this.providesUpsightUserAttributesProvider =
        DoubleCheck.provider(
            ProviderModule_ProvidesUpsightUserAttributesFactory.create(
                builder.providerModule, userAttributesProvider));

    this.provideGooglePlayHelperProvider =
        DoubleCheck.provider(
            BaseAnalyticsModule_ProvideGooglePlayHelperFactory.create(
                builder.baseAnalyticsModule, provideUpsightContextProvider));

    this.analyticsProvider =
        DoubleCheck.provider(
            Analytics_Factory.create(
                provideUpsightContextProvider,
                provideManualTrackerProvider,
                providesSessionManagerProvider,
                provideSchemaSelectorBuilderProvider,
                provideAssociationManagerProvider,
                providesOptOutStatusProvider,
                providesUpsightLocationTrackerProvider,
                providesUpsightUserAttributesProvider,
                provideGooglePlayHelperProvider));

    this.provideUpsightAnalyticsApiProvider =
        DoubleCheck.provider(
            AnalyticsApiModule_ProvideUpsightAnalyticsApiFactory.create(
                builder.analyticsApiModule, analyticsProvider));

    this.activityLifecycleTrackerProvider =
        ActivityLifecycleTracker_Factory.create(manualTrackerProvider);

    this.provideUpsightLifeCycleCallbacksProvider =
        DoubleCheck.provider(
            LifecycleTrackerModule_ProvideUpsightLifeCycleCallbacksFactory.create(
                builder.lifecycleTrackerModule, activityLifecycleTrackerProvider));

    this.upsightAnalyticsExtensionMembersInjector =
        UpsightAnalyticsExtension_MembersInjector.create(
            provideUncaughtExceptionHandlerProvider,
            provideUpsightAnalyticsApiProvider,
            provideClockProvider,
            provideUpsightLifeCycleCallbacksProvider,
            provideAssociationManagerProvider);

    this.configurationResponseParserProvider =
        DoubleCheck.provider(
            ConfigurationResponseParser_Factory.create(
                provideConfigGsonProvider, providesSessionManagerProvider));

    this.managerConfigParserProvider =
        DoubleCheck.provider(ManagerConfigParser_Factory.create(provideConfigGsonProvider));

    this.provideConfigurationManagerProvider =
        DoubleCheck.provider(
            ConfigurationModule_ProvideConfigurationManagerFactory.create(
                builder.configurationModule,
                provideUpsightContextProvider,
                configurationResponseParserProvider,
                managerConfigParserProvider));

    this.analyticsContextProvider =
        AnalyticsContext_Factory.create(
            MembersInjectors.<AnalyticsContext>noOp(), provideUpsightContextProvider);

    this.configParserProvider2 =
        DoubleCheck.provider(
            com.upsight.android.analytics.internal.dispatcher.ConfigParser_Factory.create(
                provideUpsightContextProvider, provideConfigGsonProvider));

    this.provideSendingExecutorProvider =
        DoubleCheck.provider(
            AnalyticsSchedulersModule_ProvideSendingExecutorFactory.create(
                builder.analyticsSchedulersModule));

    this.provideSchedulingExecutorProvider =
        DoubleCheck.provider(
            AnalyticsSchedulersModule_ProvideSchedulingExecutorFactory.create(
                builder.analyticsSchedulersModule));

    this.provideResponseVerifierProvider =
        DoubleCheck.provider(
            DeliveryModule_ProvideResponseVerifierFactory.create(
                builder.deliveryModule, provideUpsightContextProvider));

    this.responseParserProvider = ResponseParser_Factory.create(provideConfigGsonProvider);

    this.provideQueueBuilderProvider =
        DoubleCheck.provider(
            DeliveryModule_ProvideQueueBuilderFactory.create(
                builder.deliveryModule,
                provideUpsightContextProvider,
                provideClockProvider,
                provideSendingExecutorProvider,
                provideSchedulingExecutorProvider,
                provideResponseVerifierProvider,
                responseParserProvider));

    this.provideRouterBuilderProvider =
        DoubleCheck.provider(
            RoutingModule_ProvideRouterBuilderFactory.create(
                builder.routingModule, provideUpsightContextProvider, provideQueueBuilderProvider));

    this.provideDispatcherProvider =
        DoubleCheck.provider(
            DispatchModule_ProvideDispatcherFactory.create(
                builder.dispatchModule,
                provideUpsightContextProvider,
                providesSessionManagerProvider,
                analyticsContextProvider,
                configParserProvider2,
                provideRouterBuilderProvider,
                provideSchemaSelectorBuilderProvider));

    this.dispatcherServiceMembersInjector =
        DispatcherService_MembersInjector.create(
            provideConfigurationManagerProvider, provideDispatcherProvider);
  }

  @Override
  public void inject(UpsightAnalyticsExtension arg0) {
    upsightAnalyticsExtensionMembersInjector.injectMembers(arg0);
  }

  @Override
  public Clock clock() {
    return provideClockProvider.get();
  }

  @Override
  public SessionManager sessionManager() {
    return providesSessionManagerProvider.get();
  }

  @Override
  public void inject(DispatcherService dispatcherService) {
    dispatcherServiceMembersInjector.injectMembers(dispatcherService);
  }

  public static final class Builder {
    private BaseAnalyticsModule baseAnalyticsModule;

    private ConfigGsonModule configGsonModule;

    private SessionModule sessionModule;

    private LifecycleTrackerModule lifecycleTrackerModule;

    private SchemaModule schemaModule;

    private AssociationModule associationModule;

    private ProviderModule providerModule;

    private AnalyticsApiModule analyticsApiModule;

    private ConfigurationModule configurationModule;

    private AnalyticsSchedulersModule analyticsSchedulersModule;

    private DeliveryModule deliveryModule;

    private RoutingModule routingModule;

    private DispatchModule dispatchModule;

    private Builder() {}

    public AnalyticsComponent build() {
      if (baseAnalyticsModule == null) {
        throw new IllegalStateException(
            BaseAnalyticsModule.class.getCanonicalName() + " must be set");
      }
      if (configGsonModule == null) {
        this.configGsonModule = new ConfigGsonModule();
      }
      if (sessionModule == null) {
        this.sessionModule = new SessionModule();
      }
      if (lifecycleTrackerModule == null) {
        this.lifecycleTrackerModule = new LifecycleTrackerModule();
      }
      if (schemaModule == null) {
        this.schemaModule = new SchemaModule();
      }
      if (associationModule == null) {
        this.associationModule = new AssociationModule();
      }
      if (providerModule == null) {
        this.providerModule = new ProviderModule();
      }
      if (analyticsApiModule == null) {
        this.analyticsApiModule = new AnalyticsApiModule();
      }
      if (configurationModule == null) {
        this.configurationModule = new ConfigurationModule();
      }
      if (analyticsSchedulersModule == null) {
        this.analyticsSchedulersModule = new AnalyticsSchedulersModule();
      }
      if (deliveryModule == null) {
        this.deliveryModule = new DeliveryModule();
      }
      if (routingModule == null) {
        this.routingModule = new RoutingModule();
      }
      if (dispatchModule == null) {
        this.dispatchModule = new DispatchModule();
      }
      return new DaggerAnalyticsComponent(this);
    }

    /**
     * @deprecated This module is declared, but an instance is not used in the component. This method is a no-op. For more, see https://google.github.io/dagger/unused-modules.
     */
    @Deprecated
    public Builder analyticsModule(AnalyticsModule analyticsModule) {
      Preconditions.checkNotNull(analyticsModule);
      return this;
    }

    public Builder analyticsApiModule(AnalyticsApiModule analyticsApiModule) {
      this.analyticsApiModule = Preconditions.checkNotNull(analyticsApiModule);
      return this;
    }

    public Builder analyticsSchedulersModule(AnalyticsSchedulersModule analyticsSchedulersModule) {
      this.analyticsSchedulersModule = Preconditions.checkNotNull(analyticsSchedulersModule);
      return this;
    }

    public Builder configGsonModule(ConfigGsonModule configGsonModule) {
      this.configGsonModule = Preconditions.checkNotNull(configGsonModule);
      return this;
    }

    public Builder dispatchModule(DispatchModule dispatchModule) {
      this.dispatchModule = Preconditions.checkNotNull(dispatchModule);
      return this;
    }

    public Builder deliveryModule(DeliveryModule deliveryModule) {
      this.deliveryModule = Preconditions.checkNotNull(deliveryModule);
      return this;
    }

    public Builder routingModule(RoutingModule routingModule) {
      this.routingModule = Preconditions.checkNotNull(routingModule);
      return this;
    }

    public Builder schemaModule(SchemaModule schemaModule) {
      this.schemaModule = Preconditions.checkNotNull(schemaModule);
      return this;
    }

    public Builder configurationModule(ConfigurationModule configurationModule) {
      this.configurationModule = Preconditions.checkNotNull(configurationModule);
      return this;
    }

    public Builder sessionModule(SessionModule sessionModule) {
      this.sessionModule = Preconditions.checkNotNull(sessionModule);
      return this;
    }

    public Builder lifecycleTrackerModule(LifecycleTrackerModule lifecycleTrackerModule) {
      this.lifecycleTrackerModule = Preconditions.checkNotNull(lifecycleTrackerModule);
      return this;
    }

    public Builder providerModule(ProviderModule providerModule) {
      this.providerModule = Preconditions.checkNotNull(providerModule);
      return this;
    }

    public Builder associationModule(AssociationModule associationModule) {
      this.associationModule = Preconditions.checkNotNull(associationModule);
      return this;
    }

    public Builder baseAnalyticsModule(BaseAnalyticsModule baseAnalyticsModule) {
      this.baseAnalyticsModule = Preconditions.checkNotNull(baseAnalyticsModule);
      return this;
    }
  }
}
