package com.upsight.android.googlepushservices.internal;

import com.google.android.gms.gcm.GoogleCloudMessaging;
import com.upsight.android.UpsightContext;
import com.upsight.android.UpsightGooglePushServicesExtension;
import com.upsight.android.UpsightGooglePushServicesExtension_MembersInjector;
import com.upsight.android.analytics.internal.session.SessionManager;
import com.upsight.android.googlepushservices.UpsightGooglePushServicesApi;
import dagger.MembersInjector;
import dagger.internal.DoubleCheck;
import dagger.internal.Preconditions;
import javax.annotation.Generated;
import javax.inject.Provider;

@Generated(
  value = "dagger.internal.codegen.ComponentProcessor",
  comments = "https://google.github.io/dagger"
)
public final class DaggerGooglePushServicesComponent implements GooglePushServicesComponent {
  private Provider<UpsightContext> provideUpsightContextProvider;

  private Provider<PushConfigManager> providePushConfigManagerProvider;

  private Provider<GooglePushServices> googlePushServicesProvider;

  private Provider<UpsightGooglePushServicesApi> provideGooglePushServicesApiProvider;

  private MembersInjector<UpsightGooglePushServicesExtension>
      upsightGooglePushServicesExtensionMembersInjector;

  private Provider<GoogleCloudMessaging> provideGoogleCloudMessagingProvider;

  private MembersInjector<PushIntentService> pushIntentServiceMembersInjector;

  private Provider<SessionManager> provideSessionManagerProvider;

  private MembersInjector<PushClickIntentService> pushClickIntentServiceMembersInjector;

  private DaggerGooglePushServicesComponent(Builder builder) {
    assert builder != null;
    initialize(builder);
  }

  public static Builder builder() {
    return new Builder();
  }

  @SuppressWarnings("unchecked")
  private void initialize(final Builder builder) {

    this.provideUpsightContextProvider =
        DoubleCheck.provider(PushModule_ProvideUpsightContextFactory.create(builder.pushModule));

    this.providePushConfigManagerProvider =
        DoubleCheck.provider(
            PushModule_ProvidePushConfigManagerFactory.create(
                builder.pushModule, provideUpsightContextProvider));

    this.googlePushServicesProvider =
        DoubleCheck.provider(
            GooglePushServices_Factory.create(
                provideUpsightContextProvider, providePushConfigManagerProvider));

    this.provideGooglePushServicesApiProvider =
        DoubleCheck.provider(
            PushModule_ProvideGooglePushServicesApiFactory.create(
                builder.pushModule, googlePushServicesProvider));

    this.upsightGooglePushServicesExtensionMembersInjector =
        UpsightGooglePushServicesExtension_MembersInjector.create(
            provideGooglePushServicesApiProvider, providePushConfigManagerProvider);

    this.provideGoogleCloudMessagingProvider =
        DoubleCheck.provider(
            GoogleCloudMessagingModule_ProvideGoogleCloudMessagingFactory.create(
                builder.googleCloudMessagingModule, provideUpsightContextProvider));

    this.pushIntentServiceMembersInjector =
        PushIntentService_MembersInjector.create(
            provideGoogleCloudMessagingProvider, provideUpsightContextProvider);

    this.provideSessionManagerProvider =
        DoubleCheck.provider(
            PushModule_ProvideSessionManagerFactory.create(
                builder.pushModule, provideUpsightContextProvider));

    this.pushClickIntentServiceMembersInjector =
        PushClickIntentService_MembersInjector.create(provideSessionManagerProvider);
  }

  @Override
  public void inject(UpsightGooglePushServicesExtension arg0) {
    upsightGooglePushServicesExtensionMembersInjector.injectMembers(arg0);
  }

  @Override
  public void inject(PushIntentService pushIntentService) {
    pushIntentServiceMembersInjector.injectMembers(pushIntentService);
  }

  @Override
  public void inject(PushClickIntentService pushClickIntentService) {
    pushClickIntentServiceMembersInjector.injectMembers(pushClickIntentService);
  }

  public static final class Builder {
    private PushModule pushModule;

    private GoogleCloudMessagingModule googleCloudMessagingModule;

    private Builder() {}

    public GooglePushServicesComponent build() {
      if (pushModule == null) {
        throw new IllegalStateException(PushModule.class.getCanonicalName() + " must be set");
      }
      if (googleCloudMessagingModule == null) {
        this.googleCloudMessagingModule = new GoogleCloudMessagingModule();
      }
      return new DaggerGooglePushServicesComponent(this);
    }

    /**
     * @deprecated This module is declared, but an instance is not used in the component. This method is a no-op. For more, see https://google.github.io/dagger/unused-modules.
     */
    @Deprecated
    public Builder googlePushServicesModule(GooglePushServicesModule googlePushServicesModule) {
      Preconditions.checkNotNull(googlePushServicesModule);
      return this;
    }

    public Builder pushModule(PushModule pushModule) {
      this.pushModule = Preconditions.checkNotNull(pushModule);
      return this;
    }

    public Builder googleCloudMessagingModule(
        GoogleCloudMessagingModule googleCloudMessagingModule) {
      this.googleCloudMessagingModule = Preconditions.checkNotNull(googleCloudMessagingModule);
      return this;
    }
  }
}
