package com.upsight.android.internal;

import android.content.Context;
import com.google.gson.Gson;
import com.google.gson.JsonParser;
import com.squareup.otto.Bus;
import com.upsight.android.UpsightContext;
import com.upsight.android.internal.logger.LogWriter;
import com.upsight.android.internal.logger.LoggerModule;
import com.upsight.android.internal.logger.LoggerModule_ProvideUpsightLoggerFactory;
import com.upsight.android.internal.persistence.PersistenceModule;
import com.upsight.android.internal.persistence.PersistenceModule_ProvideBackgroundDataStoreFactory;
import com.upsight.android.internal.persistence.PersistenceModule_ProvideDataStoreFactory;
import com.upsight.android.internal.persistence.storable.StorableIdFactory;
import com.upsight.android.internal.persistence.storable.StorableInfoCache;
import com.upsight.android.internal.persistence.storable.StorableModule;
import com.upsight.android.internal.persistence.storable.StorableModule_ProvideStorableInfoCacheFactory;
import com.upsight.android.logger.UpsightLogger;
import com.upsight.android.persistence.UpsightDataStore;
import dagger.internal.DoubleCheck;
import dagger.internal.Preconditions;
import javax.annotation.Generated;
import javax.inject.Provider;
import rx.Scheduler;

@Generated(
  value = "dagger.internal.codegen.ComponentProcessor",
  comments = "https://google.github.io/dagger"
)
public final class DaggerCoreComponent implements CoreComponent {
  private Provider<Context> provideApplicationContextProvider;

  private Provider<Gson> provideGsonProvider;

  private Provider<StorableInfoCache> provideStorableInfoCacheProvider;

  private Provider<StorableIdFactory> provideTypeIdGeneratorProvider;

  private Provider<Scheduler> provideSubscribeOnSchedulerProvider;

  private Provider<Scheduler> provideObserveOnSchedulerProvider;

  private Provider<Bus> provideBusProvider;

  private Provider<UpsightDataStore> provideDataStoreProvider;

  private Provider<LogWriter> provideLogWriterProvider;

  private Provider<UpsightLogger> provideUpsightLoggerProvider;

  private Provider<String> provideSdkPluginProvider;

  private Provider<String> provideApplicationTokenProvider;

  private Provider<String> providePublicKeyProvider;

  private Provider<UpsightContext> provideUpsightContextProvider;

  private Provider<JsonParser> provideJsonParserProvider;

  private Provider<UpsightDataStore> provideBackgroundDataStoreProvider;

  private DaggerCoreComponent(Builder builder) {
    assert builder != null;
    initialize(builder);
  }

  public static Builder builder() {
    return new Builder();
  }

  @SuppressWarnings("unchecked")
  private void initialize(final Builder builder) {

    this.provideApplicationContextProvider =
        DoubleCheck.provider(
            ContextModule_ProvideApplicationContextFactory.create(builder.contextModule));

    this.provideGsonProvider =
        DoubleCheck.provider(JsonModule_ProvideGsonFactory.create(builder.jsonModule));

    this.provideStorableInfoCacheProvider =
        DoubleCheck.provider(
            StorableModule_ProvideStorableInfoCacheFactory.create(
                builder.storableModule, provideGsonProvider));

    this.provideTypeIdGeneratorProvider =
        DoubleCheck.provider(
            ContextModule_ProvideTypeIdGeneratorFactory.create(builder.contextModule));

    this.provideSubscribeOnSchedulerProvider =
        DoubleCheck.provider(
            SchedulersModule_ProvideSubscribeOnSchedulerFactory.create(builder.schedulersModule));

    this.provideObserveOnSchedulerProvider =
        DoubleCheck.provider(
            SchedulersModule_ProvideObserveOnSchedulerFactory.create(builder.schedulersModule));

    this.provideBusProvider =
        DoubleCheck.provider(ContextModule_ProvideBusFactory.create(builder.contextModule));

    this.provideDataStoreProvider =
        DoubleCheck.provider(
            PersistenceModule_ProvideDataStoreFactory.create(
                builder.persistenceModule,
                provideApplicationContextProvider,
                provideStorableInfoCacheProvider,
                provideTypeIdGeneratorProvider,
                provideSubscribeOnSchedulerProvider,
                provideObserveOnSchedulerProvider,
                provideBusProvider));

    this.provideLogWriterProvider =
        DoubleCheck.provider(ContextModule_ProvideLogWriterFactory.create(builder.contextModule));

    this.provideUpsightLoggerProvider =
        DoubleCheck.provider(
            LoggerModule_ProvideUpsightLoggerFactory.create(
                builder.loggerModule, provideDataStoreProvider, provideLogWriterProvider));

    this.provideSdkPluginProvider =
        DoubleCheck.provider(
            PropertiesModule_ProvideSdkPluginFactory.create(
                builder.propertiesModule,
                provideApplicationContextProvider,
                provideUpsightLoggerProvider));

    this.provideApplicationTokenProvider =
        DoubleCheck.provider(
            PropertiesModule_ProvideApplicationTokenFactory.create(
                builder.propertiesModule,
                provideApplicationContextProvider,
                provideUpsightLoggerProvider));

    this.providePublicKeyProvider =
        DoubleCheck.provider(
            PropertiesModule_ProvidePublicKeyFactory.create(
                builder.propertiesModule,
                provideApplicationContextProvider,
                provideUpsightLoggerProvider));

    this.provideUpsightContextProvider =
        DoubleCheck.provider(
            UpsightContextModule_ProvideUpsightContextFactory.create(
                builder.upsightContextModule,
                provideApplicationContextProvider,
                provideSdkPluginProvider,
                provideApplicationTokenProvider,
                providePublicKeyProvider,
                provideDataStoreProvider,
                provideUpsightLoggerProvider));

    this.provideJsonParserProvider =
        DoubleCheck.provider(JsonModule_ProvideJsonParserFactory.create(builder.jsonModule));

    this.provideBackgroundDataStoreProvider =
        DoubleCheck.provider(
            PersistenceModule_ProvideBackgroundDataStoreFactory.create(
                builder.persistenceModule,
                provideApplicationContextProvider,
                provideSubscribeOnSchedulerProvider,
                provideTypeIdGeneratorProvider,
                provideStorableInfoCacheProvider,
                provideBusProvider));
  }

  @Override
  public UpsightContext upsightContext() {
    return provideUpsightContextProvider.get();
  }

  @Override
  public Context applicationContext() {
    return provideApplicationContextProvider.get();
  }

  @Override
  public Bus bus() {
    return provideBusProvider.get();
  }

  @Override
  public Gson gson() {
    return provideGsonProvider.get();
  }

  @Override
  public JsonParser jsonParser() {
    return provideJsonParserProvider.get();
  }

  @Override
  public Scheduler subscribeOnScheduler() {
    return provideSubscribeOnSchedulerProvider.get();
  }

  @Override
  public Scheduler observeOnScheduler() {
    return provideObserveOnSchedulerProvider.get();
  }

  @Override
  public UpsightDataStore backgroundDataStore() {
    return provideBackgroundDataStoreProvider.get();
  }

  public static final class Builder {
    private ContextModule contextModule;

    private JsonModule jsonModule;

    private StorableModule storableModule;

    private SchedulersModule schedulersModule;

    private PersistenceModule persistenceModule;

    private LoggerModule loggerModule;

    private PropertiesModule propertiesModule;

    private UpsightContextModule upsightContextModule;

    private Builder() {}

    public CoreComponent build() {
      if (contextModule == null) {
        throw new IllegalStateException(ContextModule.class.getCanonicalName() + " must be set");
      }
      if (jsonModule == null) {
        this.jsonModule = new JsonModule();
      }
      if (storableModule == null) {
        this.storableModule = new StorableModule();
      }
      if (schedulersModule == null) {
        this.schedulersModule = new SchedulersModule();
      }
      if (persistenceModule == null) {
        this.persistenceModule = new PersistenceModule();
      }
      if (loggerModule == null) {
        this.loggerModule = new LoggerModule();
      }
      if (propertiesModule == null) {
        this.propertiesModule = new PropertiesModule();
      }
      if (upsightContextModule == null) {
        this.upsightContextModule = new UpsightContextModule();
      }
      return new DaggerCoreComponent(this);
    }

    /**
     * @deprecated This module is declared, but an instance is not used in the component. This method is a no-op. For more, see https://google.github.io/dagger/unused-modules.
     */
    @Deprecated
    public Builder coreModule(CoreModule coreModule) {
      Preconditions.checkNotNull(coreModule);
      return this;
    }

    public Builder upsightContextModule(UpsightContextModule upsightContextModule) {
      this.upsightContextModule = Preconditions.checkNotNull(upsightContextModule);
      return this;
    }

    public Builder contextModule(ContextModule contextModule) {
      this.contextModule = Preconditions.checkNotNull(contextModule);
      return this;
    }

    public Builder propertiesModule(PropertiesModule propertiesModule) {
      this.propertiesModule = Preconditions.checkNotNull(propertiesModule);
      return this;
    }

    public Builder jsonModule(JsonModule jsonModule) {
      this.jsonModule = Preconditions.checkNotNull(jsonModule);
      return this;
    }

    public Builder schedulersModule(SchedulersModule schedulersModule) {
      this.schedulersModule = Preconditions.checkNotNull(schedulersModule);
      return this;
    }

    public Builder storableModule(StorableModule storableModule) {
      this.storableModule = Preconditions.checkNotNull(storableModule);
      return this;
    }

    public Builder persistenceModule(PersistenceModule persistenceModule) {
      this.persistenceModule = Preconditions.checkNotNull(persistenceModule);
      return this;
    }

    public Builder loggerModule(LoggerModule loggerModule) {
      this.loggerModule = Preconditions.checkNotNull(loggerModule);
      return this;
    }
  }
}
