package com.upsight.android.managedvariables.internal;

import com.google.gson.Gson;
import com.google.gson.JsonParser;
import com.upsight.android.UpsightContext;
import com.upsight.android.UpsightManagedVariablesExtension;
import com.upsight.android.UpsightManagedVariablesExtension_MembersInjector;
import com.upsight.android.managedvariables.UpsightManagedVariablesApi;
import com.upsight.android.managedvariables.experience.UpsightUserExperience;
import com.upsight.android.managedvariables.internal.experience.UserExperienceModule;
import com.upsight.android.managedvariables.internal.experience.UserExperienceModule_ProvideUserExperienceFactory;
import com.upsight.android.managedvariables.internal.type.ManagedVariableManager;
import com.upsight.android.managedvariables.internal.type.UxmBlockProvider;
import com.upsight.android.managedvariables.internal.type.UxmContentFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideManagedVariableManagerFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmBlockProviderFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmContentFactoryFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmSchemaFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmSchemaGsonFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmSchemaJsonParserFactory;
import com.upsight.android.managedvariables.internal.type.UxmModule_ProvideUxmSchemaRawStringFactory;
import com.upsight.android.managedvariables.internal.type.UxmSchema;
import dagger.MembersInjector;
import dagger.internal.DoubleCheck;
import dagger.internal.Preconditions;
import javax.annotation.Generated;
import javax.inject.Provider;
import rx.Scheduler;

@Generated(
  value = "dagger.internal.codegen.ComponentProcessor",
  comments = "https://google.github.io/dagger"
)
public final class DaggerManagedVariablesComponent implements ManagedVariablesComponent {
  private Provider<UpsightContext> provideUpsightContextProvider;

  private Provider<Scheduler> provideMainSchedulerProvider;

  private Provider<Gson> provideUxmSchemaGsonProvider;

  private Provider<JsonParser> provideUxmSchemaJsonParserProvider;

  private Provider<Integer> provideUxmSchemaResourceProvider;

  private Provider<String> provideUxmSchemaRawStringProvider;

  private Provider<UxmSchema> provideUxmSchemaProvider;

  private Provider<ManagedVariableManager> provideManagedVariableManagerProvider;

  private Provider<UpsightUserExperience> provideUserExperienceProvider;

  private Provider<UpsightManagedVariablesApi> provideManagedVariablesApiProvider;

  private Provider<UxmContentFactory> provideUxmContentFactoryProvider;

  private Provider<UxmBlockProvider> provideUxmBlockProvider;

  private MembersInjector<UpsightManagedVariablesExtension>
      upsightManagedVariablesExtensionMembersInjector;

  private DaggerManagedVariablesComponent(Builder builder) {
    assert builder != null;
    initialize(builder);
  }

  public static Builder builder() {
    return new Builder();
  }

  @SuppressWarnings("unchecked")
  private void initialize(final Builder builder) {

    this.provideUpsightContextProvider =
        DoubleCheck.provider(
            BaseManagedVariablesModule_ProvideUpsightContextFactory.create(
                builder.baseManagedVariablesModule));

    this.provideMainSchedulerProvider =
        DoubleCheck.provider(
            BaseManagedVariablesModule_ProvideMainSchedulerFactory.create(
                builder.baseManagedVariablesModule));

    this.provideUxmSchemaGsonProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmSchemaGsonFactory.create(
                builder.uxmModule, provideUpsightContextProvider));

    this.provideUxmSchemaJsonParserProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmSchemaJsonParserFactory.create(
                builder.uxmModule, provideUpsightContextProvider));

    this.provideUxmSchemaResourceProvider =
        DoubleCheck.provider(
            ResourceModule_ProvideUxmSchemaResourceFactory.create(builder.resourceModule));

    this.provideUxmSchemaRawStringProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmSchemaRawStringFactory.create(
                builder.uxmModule,
                provideUpsightContextProvider,
                provideUxmSchemaResourceProvider));

    this.provideUxmSchemaProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmSchemaFactory.create(
                builder.uxmModule,
                provideUpsightContextProvider,
                provideUxmSchemaGsonProvider,
                provideUxmSchemaJsonParserProvider,
                provideUxmSchemaRawStringProvider));

    this.provideManagedVariableManagerProvider =
        DoubleCheck.provider(
            UxmModule_ProvideManagedVariableManagerFactory.create(
                builder.uxmModule,
                provideUpsightContextProvider,
                provideMainSchedulerProvider,
                provideUxmSchemaProvider));

    this.provideUserExperienceProvider =
        DoubleCheck.provider(
            UserExperienceModule_ProvideUserExperienceFactory.create(
                builder.userExperienceModule, provideUpsightContextProvider));

    this.provideManagedVariablesApiProvider =
        DoubleCheck.provider(
            BaseManagedVariablesModule_ProvideManagedVariablesApiFactory.create(
                builder.baseManagedVariablesModule,
                provideManagedVariableManagerProvider,
                provideUserExperienceProvider));

    this.provideUxmContentFactoryProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmContentFactoryFactory.create(
                builder.uxmModule,
                provideUpsightContextProvider,
                provideMainSchedulerProvider,
                provideUserExperienceProvider));

    this.provideUxmBlockProvider =
        DoubleCheck.provider(
            UxmModule_ProvideUxmBlockProviderFactory.create(
                builder.uxmModule,
                provideUpsightContextProvider,
                provideUxmSchemaRawStringProvider,
                provideUxmSchemaProvider));

    this.upsightManagedVariablesExtensionMembersInjector =
        UpsightManagedVariablesExtension_MembersInjector.create(
            provideManagedVariablesApiProvider,
            provideUxmContentFactoryProvider,
            provideUxmBlockProvider);
  }

  @Override
  public void inject(UpsightManagedVariablesExtension arg0) {
    upsightManagedVariablesExtensionMembersInjector.injectMembers(arg0);
  }

  @Override
  public UxmSchema uxmSchema() {
    return provideUxmSchemaProvider.get();
  }

  public static final class Builder {
    private BaseManagedVariablesModule baseManagedVariablesModule;

    private UxmModule uxmModule;

    private ResourceModule resourceModule;

    private UserExperienceModule userExperienceModule;

    private Builder() {}

    public ManagedVariablesComponent build() {
      if (baseManagedVariablesModule == null) {
        throw new IllegalStateException(
            BaseManagedVariablesModule.class.getCanonicalName() + " must be set");
      }
      if (uxmModule == null) {
        this.uxmModule = new UxmModule();
      }
      if (resourceModule == null) {
        this.resourceModule = new ResourceModule();
      }
      if (userExperienceModule == null) {
        this.userExperienceModule = new UserExperienceModule();
      }
      return new DaggerManagedVariablesComponent(this);
    }

    /**
     * @deprecated This module is declared, but an instance is not used in the component. This method is a no-op. For more, see https://google.github.io/dagger/unused-modules.
     */
    @Deprecated
    public Builder managedVariablesModule(ManagedVariablesModule managedVariablesModule) {
      Preconditions.checkNotNull(managedVariablesModule);
      return this;
    }

    public Builder resourceModule(ResourceModule resourceModule) {
      this.resourceModule = Preconditions.checkNotNull(resourceModule);
      return this;
    }

    public Builder uxmModule(UxmModule uxmModule) {
      this.uxmModule = Preconditions.checkNotNull(uxmModule);
      return this;
    }

    public Builder userExperienceModule(UserExperienceModule userExperienceModule) {
      this.userExperienceModule = Preconditions.checkNotNull(userExperienceModule);
      return this;
    }

    public Builder baseManagedVariablesModule(
        BaseManagedVariablesModule baseManagedVariablesModule) {
      this.baseManagedVariablesModule = Preconditions.checkNotNull(baseManagedVariablesModule);
      return this;
    }
  }
}
