package com.upsight.android.marketing.internal;

import com.upsight.android.UpsightContext;
import com.upsight.android.UpsightMarketingExtension;
import com.upsight.android.UpsightMarketingExtension_MembersInjector;
import com.upsight.android.marketing.UpsightBillboardManager;
import com.upsight.android.marketing.UpsightMarketingApi;
import com.upsight.android.marketing.UpsightMarketingContentStore;
import com.upsight.android.marketing.internal.billboard.BillboardDialogFragment;
import com.upsight.android.marketing.internal.billboard.BillboardDialogFragment_MembersInjector;
import com.upsight.android.marketing.internal.billboard.BillboardManagementActivity;
import com.upsight.android.marketing.internal.billboard.BillboardManagementActivity_MembersInjector;
import com.upsight.android.marketing.internal.billboard.BillboardModule;
import com.upsight.android.marketing.internal.billboard.BillboardModule_ProvideBillboardManagerFactory;
import com.upsight.android.marketing.internal.content.ContentModule;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideDefaultContentMediatorFactory;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideMarketingContentFactoryFactory;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideMarketingContentMediatorManagerFactory;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideMarketingContentStoreFactory;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideMarketingContentStoreImplFactory;
import com.upsight.android.marketing.internal.content.ContentModule_ProvideUpsightMarketingContentStoreFactory;
import com.upsight.android.marketing.internal.content.ContentTemplateWebViewClientFactory;
import com.upsight.android.marketing.internal.content.DefaultContentMediator;
import com.upsight.android.marketing.internal.content.MarketingContentFactory;
import com.upsight.android.marketing.internal.content.MarketingContentMediatorManager;
import com.upsight.android.marketing.internal.content.MarketingContentStore;
import com.upsight.android.marketing.internal.content.WebViewModule;
import com.upsight.android.marketing.internal.content.WebViewModule_ProvideContentTemplateWebViewClientFactoryFactory;
import dagger.MembersInjector;
import dagger.internal.DoubleCheck;
import dagger.internal.Preconditions;
import javax.annotation.Generated;
import javax.inject.Provider;
import rx.Scheduler;

@Generated(
  value = "dagger.internal.codegen.ComponentProcessor",
  comments = "https://google.github.io/dagger"
)
public final class DaggerMarketingComponent implements MarketingComponent {
  private Provider<UpsightContext> provideUpsightContextProvider;

  @SuppressWarnings("rawtypes")
  private Provider provideMarketingContentStoreImplProvider;

  private Provider<MarketingContentStore> provideMarketingContentStoreProvider;

  private Provider<UpsightBillboardManager> provideBillboardManagerProvider;

  private Provider<UpsightMarketingContentStore> provideUpsightMarketingContentStoreProvider;

  private Provider<DefaultContentMediator> provideDefaultContentMediatorProvider;

  private Provider<MarketingContentMediatorManager> provideMarketingContentMediatorManagerProvider;

  private Provider<UpsightMarketingApi> provideMarketingApiProvider;

  private Provider<Scheduler> provideMainSchedulerProvider;

  private Provider<ContentTemplateWebViewClientFactory>
      provideContentTemplateWebViewClientFactoryProvider;

  private Provider<MarketingContentFactory> provideMarketingContentFactoryProvider;

  private MembersInjector<UpsightMarketingExtension> upsightMarketingExtensionMembersInjector;

  private MembersInjector<BillboardManagementActivity> billboardManagementActivityMembersInjector;

  private MembersInjector<BillboardDialogFragment> billboardDialogFragmentMembersInjector;

  private DaggerMarketingComponent(Builder builder) {
    assert builder != null;
    initialize(builder);
  }

  public static Builder builder() {
    return new Builder();
  }

  @SuppressWarnings("unchecked")
  private void initialize(final Builder builder) {

    this.provideUpsightContextProvider =
        DoubleCheck.provider(
            BaseMarketingModule_ProvideUpsightContextFactory.create(builder.baseMarketingModule));

    this.provideMarketingContentStoreImplProvider =
        DoubleCheck.provider(
            ContentModule_ProvideMarketingContentStoreImplFactory.create(
                builder.contentModule, provideUpsightContextProvider));

    this.provideMarketingContentStoreProvider =
        DoubleCheck.provider(
            ContentModule_ProvideMarketingContentStoreFactory.create(
                builder.contentModule, provideMarketingContentStoreImplProvider));

    this.provideBillboardManagerProvider =
        DoubleCheck.provider(
            BillboardModule_ProvideBillboardManagerFactory.create(
                builder.billboardModule,
                provideUpsightContextProvider,
                provideMarketingContentStoreProvider));

    this.provideUpsightMarketingContentStoreProvider =
        DoubleCheck.provider(
            ContentModule_ProvideUpsightMarketingContentStoreFactory.create(
                builder.contentModule, provideMarketingContentStoreImplProvider));

    this.provideDefaultContentMediatorProvider =
        DoubleCheck.provider(
            ContentModule_ProvideDefaultContentMediatorFactory.create(builder.contentModule));

    this.provideMarketingContentMediatorManagerProvider =
        DoubleCheck.provider(
            ContentModule_ProvideMarketingContentMediatorManagerFactory.create(
                builder.contentModule, provideDefaultContentMediatorProvider));

    this.provideMarketingApiProvider =
        DoubleCheck.provider(
            BaseMarketingModule_ProvideMarketingApiFactory.create(
                builder.baseMarketingModule,
                provideBillboardManagerProvider,
                provideUpsightMarketingContentStoreProvider,
                provideMarketingContentMediatorManagerProvider));

    this.provideMainSchedulerProvider =
        DoubleCheck.provider(
            BaseMarketingModule_ProvideMainSchedulerFactory.create(builder.baseMarketingModule));

    this.provideContentTemplateWebViewClientFactoryProvider =
        DoubleCheck.provider(
            WebViewModule_ProvideContentTemplateWebViewClientFactoryFactory.create(
                builder.webViewModule, provideUpsightContextProvider));

    this.provideMarketingContentFactoryProvider =
        DoubleCheck.provider(
            ContentModule_ProvideMarketingContentFactoryFactory.create(
                builder.contentModule,
                provideUpsightContextProvider,
                provideMainSchedulerProvider,
                provideMarketingContentMediatorManagerProvider,
                provideMarketingContentStoreProvider,
                provideContentTemplateWebViewClientFactoryProvider));

    this.upsightMarketingExtensionMembersInjector =
        UpsightMarketingExtension_MembersInjector.create(
            provideMarketingApiProvider,
            provideMarketingContentFactoryProvider,
            provideDefaultContentMediatorProvider);

    this.billboardManagementActivityMembersInjector =
        BillboardManagementActivity_MembersInjector.create(
            provideUpsightContextProvider, provideMarketingContentStoreProvider);

    this.billboardDialogFragmentMembersInjector =
        BillboardDialogFragment_MembersInjector.create(
            provideUpsightContextProvider, provideMarketingContentStoreProvider);
  }

  @Override
  public void inject(UpsightMarketingExtension arg0) {
    upsightMarketingExtensionMembersInjector.injectMembers(arg0);
  }

  @Override
  public void inject(BillboardManagementActivity activity) {
    billboardManagementActivityMembersInjector.injectMembers(activity);
  }

  @Override
  public void inject(BillboardDialogFragment fragment) {
    billboardDialogFragmentMembersInjector.injectMembers(fragment);
  }

  public static final class Builder {
    private BaseMarketingModule baseMarketingModule;

    private ContentModule contentModule;

    private BillboardModule billboardModule;

    private WebViewModule webViewModule;

    private Builder() {}

    public MarketingComponent build() {
      if (baseMarketingModule == null) {
        throw new IllegalStateException(
            BaseMarketingModule.class.getCanonicalName() + " must be set");
      }
      if (contentModule == null) {
        this.contentModule = new ContentModule();
      }
      if (billboardModule == null) {
        this.billboardModule = new BillboardModule();
      }
      if (webViewModule == null) {
        this.webViewModule = new WebViewModule();
      }
      return new DaggerMarketingComponent(this);
    }

    /**
     * @deprecated This module is declared, but an instance is not used in the component. This method is a no-op. For more, see https://google.github.io/dagger/unused-modules.
     */
    @Deprecated
    public Builder marketingModule(MarketingModule marketingModule) {
      Preconditions.checkNotNull(marketingModule);
      return this;
    }

    public Builder billboardModule(BillboardModule billboardModule) {
      this.billboardModule = Preconditions.checkNotNull(billboardModule);
      return this;
    }

    public Builder contentModule(ContentModule contentModule) {
      this.contentModule = Preconditions.checkNotNull(contentModule);
      return this;
    }

    public Builder webViewModule(WebViewModule webViewModule) {
      this.webViewModule = Preconditions.checkNotNull(webViewModule);
      return this;
    }

    public Builder baseMarketingModule(BaseMarketingModule baseMarketingModule) {
      this.baseMarketingModule = Preconditions.checkNotNull(baseMarketingModule);
      return this;
    }
  }
}
